--------------------------------------------------------------------------------
-- Storing meta-information
--------------------------------------------------------------------------------

{-# LANGUAGE DataKinds              #-}

module Auxiliary.Metadata where


import Auxiliary.Utils

--------------------------------------------------------------------------------
-- Universe
--------------------------------------------------------------------------------

-- Now using the new type-level lits
data MetaCons = MC { conName     :: Symbol
                   , conFixity   :: Fixity
                   , conIsRecord :: Bool }

data Fixity = Prefix | Infix Associativity Nat


data Associativity =  LeftAssociative 
                   |  RightAssociative
                   |  NotAssociative


data MetaData = MD { dataName :: Symbol, dataModule :: Symbol }

data MetaSel = MS { selName :: Maybe Symbol }
